# all files / src/widgets/ OutlineOptionWidget.js

28.57% Statements 14/49
0% Branches 0/12
0% Functions 0/9
28.57% Lines 14/49

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

     /**
     * OutlineOptionWidget is an item in an {@link OO.ui.OutlineSelectWidget OutlineSelectWidget}.
     *
     * Currently, this class is only used by {@link OO.ui.BookletLayout booklet layouts}, which contain
     * {@link OO.ui.PageLayout page layouts}. See {@link OO.ui.BookletLayout BookletLayout}
     * for an example.
     *
     * @class
     * @extends OO.ui.DecoratedOptionWidget
     *
     * @constructor
     * @param {Object} [config] Configuration options
     * @cfg {number} [level] Indentation level
     * @cfg {boolean} [movable] Allow modification from {@link OO.ui.OutlineControlsWidget outline controls}.
     */
    OO.ui.OutlineOptionWidget = function OoUiOutlineOptionWidget( config ) {
    	// Configuration initialization
    	config = config || {};

    	// Parent constructor
    	OO.ui.OutlineOptionWidget.parent.call( this, config );

    	// Properties
    	this.level = 0;
    	this.movable = !!config.movable;
    	this.removable = !!config.removable;

    	// Initialization
    	this.$element.addClass( 'oo-ui-outlineOptionWidget' );
    	this.setLevel( config.level );
    };

    /* Setup */

    OO.inheritClass( OO.ui.OutlineOptionWidget, OO.ui.DecoratedOptionWidget );

    /* Static Properties */

    /**
     * @static
     * @inheritdoc
     */
    OO.ui.OutlineOptionWidget.static.highlightable = true;

    /**
     * @static
     * @inheritdoc
     */
    OO.ui.OutlineOptionWidget.static.scrollIntoViewOnSelect = true;

    /**
     * @static
     * @inheritable
     * @property {string}
     */
    OO.ui.OutlineOptionWidget.static.levelClass = 'oo-ui-outlineOptionWidget-level-';

    /**
     * @static
     * @inheritable
     * @property {number}
     */
    OO.ui.OutlineOptionWidget.static.levels = 3;

    /* Methods */

    /**
     * Check if item is movable.
     *
     * Movability is used by {@link OO.ui.OutlineControlsWidget outline controls}.
     *
     * @return {boolean} Item is movable
     */
    OO.ui.OutlineOptionWidget.prototype.isMovable = function () {
    	return this.movable;
    };

    /**
     * Check if item is removable.
     *
     * Removability is used by {@link OO.ui.OutlineControlsWidget outline controls}.
     *
     * @return {boolean} Item is removable
     */
    OO.ui.OutlineOptionWidget.prototype.isRemovable = function () {
    	return this.removable;
    };

    /**
     * Get indentation level.
     *
     * @return {number} Indentation level
     */
    OO.ui.OutlineOptionWidget.prototype.getLevel = function () {
    	return this.level;
    };

    /**
     * @inheritdoc
     */
    OO.ui.OutlineOptionWidget.prototype.setPressed = function ( state ) {
    	OO.ui.OutlineOptionWidget.parent.prototype.setPressed.call( this, state );
    	if ( this.pressed ) {
    		this.setFlags( { progressive: true } );
    	} else if ( !this.selected ) {
    		this.setFlags( { progressive: false } );
    	}
    	return this;
    };

    /**
     * Set movability.
     *
     * Movability is used by {@link OO.ui.OutlineControlsWidget outline controls}.
     *
     * @param {boolean} movable Item is movable
     * @chainable
     */
    OO.ui.OutlineOptionWidget.prototype.setMovable = function ( movable ) {
    	this.movable = !!movable;
    	this.updateThemeClasses();
    	return this;
    };

    /**
     * Set removability.
     *
     * Removability is used by {@link OO.ui.OutlineControlsWidget outline controls}.
     *
     * @param {boolean} removable Item is removable
     * @chainable
     */
    OO.ui.OutlineOptionWidget.prototype.setRemovable = function ( removable ) {
    	this.removable = !!removable;
    	this.updateThemeClasses();
    	return this;
    };

    /**
     * @inheritdoc
     */
    OO.ui.OutlineOptionWidget.prototype.setSelected = function ( state ) {
    	OO.ui.OutlineOptionWidget.parent.prototype.setSelected.call( this, state );
    	if ( this.selected ) {
    		this.setFlags( { progressive: true } );
    	} else {
    		this.setFlags( { progressive: false } );
    	}
    	return this;
    };

    /**
     * Set indentation level.
     *
     * @param {number} [level=0] Indentation level, in the range of [0,#maxLevel]
     * @chainable
     */
    OO.ui.OutlineOptionWidget.prototype.setLevel = function ( level ) {
    	var levels = this.constructor.static.levels,
    		levelClass = this.constructor.static.levelClass,
    		i = levels;

    	this.level = level ? Math.max( 0, Math.min( levels - 1, level ) ) : 0;
    	while ( i-- ) {
    		if ( this.level === i ) {
    			this.$element.addClass( levelClass + i );
    		} else {
    			this.$element.removeClass( levelClass + i );
    		}
    	}
    	this.updateThemeClasses();

    	return this;
    };